#include <stdio.h>
#include <string.h>
#include <assert.h>

class Person
{
public:
	char name[13];
	int money;

	void set(const char *Name) { money = 0; strcpy(name, Name); }
};

class People
{
public:
	Person p[10];
	int n;

	People() : n(0) { }

	int received;

	Person& operator[] (const char *name) 
	{
		for (int i = 0; i < n; i++)
			if (strcmp(p[i].name, name) == 0)
			{
				assert((received & 1 << i) == 0);
				received |= 1 << i;
				return p[i];
			}
		printf("!!! %s\n", name); assert(false); return p[n];
	}
};

int main()
{
	People people;
	char buf[200];

	freopen("gift.in", "rt", stdin);
	for (bool first = true; ; first = false)
	{
		if (! gets(buf)) break;
		if (sscanf(buf, "%d", &people.n) != 1) break;
		if (people.n <= 0) break;
		gets(buf);
		int i = 0; char *p;
		for (p = strtok(buf, " "); p; p = strtok(0, " "))
		{
			if (! *p) continue;
			assert(i < people.n);
			people.p[i++].set(p);
		}
		for (i = 0; i < people.n; i++)
		{
			gets(buf);
			char *name = strtok(buf, " ");
			int amount; sscanf(strtok(0, " "), "%d", &amount);
			int receivers; sscanf(strtok(0, " "), "%d", &receivers);
			if (receivers == 0) continue;
			people.received = 0;
			people[name].money -= receivers * (amount / receivers);
			amount /= receivers;
			while (receivers-- > 0)
				people[strtok(0, " ")].money += amount;
		}
		if (! first) printf("\n");
		for (i = 0; i < people.n; i++)
			printf("%s %d\n", people.p[i].name, people.p[i].money);
	}
	return 0;
}