#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define MAX 1001

int random(int a, int b) 
{
   return (int) ((double)rand() * (b - a + 1) / RAND_MAX) + a;
}

void MTMGen()
{
   int i;
   char out[MAX];
   srand(time(0));

   for ( int n = 0; n < 2000; n++ ) {
      int m = random(0, 7);
      for ( i = 0; i < m; i++ ) out[i] = '3';
      if ( random(0, 2) > 0 ) out[m++] = '2';
      int m1 = random(0, 9 - m);
      for ( i = m; i < m + m1; i++ ) 
         out[i] = '0' + random(0, 9);
      out[i] = 0;
      printf("%s\n", out);
   }
   printf("0\n");
}

bool MTM(char *in, char *out)
{
   if ( in[0] == '2' ) {
      strcpy(out, in + 1);
      return ( strlen(out) > 0 && strchr(out, '0') == NULL );
   }
   if ( in[0] == '3' ) {
      char buf[MAX];

      if ( !MTM(in + 1, buf) ) return false;
      strcpy(out, buf);
      strcat(out, "2");
      strcat(out, buf);
      return true;
   }
   return false;
}

int main(int argc, char *argv[])
{
   char n[MAX], out[MAX];

   if ( argc > 1 ) { MTMGen(); return 0; }

   while ( 1 ) {
      scanf("%s", n);
      if ( strcmp(n, "0") == 0 ) break;
      if ( MTM(n, out) ) printf("%s\n", out);
                    else printf("NOT ACCEPTABLE\n");
   }
   return 0;
}
